## kernel-patch-powerpc-2.6.8 2.6.8-13sarge1

=== config/Makefile ===
powerpc default:	powerpc.stub nosmp.stub cpufreq.stub common.stub
	cat $^
%-smp:	%.stub smp.stub nocpufreq.stub common.stub
	cat $^
%:	%.stub nosmp.stub nocpufreq.stub common.stub
	cat $^

## kernel-patch-powerpc-2.6.8 2.6.8-12

=== debian/changelog ===
kernel-patch-powerpc-2.6.8 (2.6.8-12) unstable; urgency=high

  * Rebuilding with added kernel-tree magic, as requested by the release
    managers to handle the abi breaking kernel-source-2.6.8-14 upload.
  * Also create the kernel-tree-version file in the documentation which
    mentions against which kernel-tree we did build.

 -- Sven Luther <luther@debian.org>  Sun, 20 Mar 2005 08:03:08 +0100

kernel-patch-powerpc-2.6.8 (2.6.8-11) unstable; urgency=high

  * Added kernel-source changelog in the kernel-image package.
  * Added mkvmlinuz as dependency to kernel-image. This is just a plain
    script, and will hold the debconfified postinst which will be run by
    the kernel-image to select the bootloader stuff.

 -- Sven Luther <luther@debian.org>  Thu, 24 Feb 2005 07:59:54 +0100

kernel-patch-powerpc-2.6.8 (2.6.8-10) unstable; urgency=high

  * Built against kernel-source 2.6.8-13 :
    - add more USB card reader blacklist entries.  Patch from Fedora via
      Otavio Salvador <otavio@debian.org>. (Christoph Hellwig) (Bug #289247)
    - Replace smbfs-overflow-fixes.patch with a newer version from 2.6.10-ac
      that actually works.  Thanks to S?ren Hansen <sh@warma.dk> for finding
      and submitting it. (Christoph Hellwig) (Bug #283241).
    - expand_stack_reorg.dpatch
      Clean up mm/mmap.c's expand_stack() function, backported from
      2.6.11-rcX.  Needed for future security patches (Andres Salomon).
    - [SECURITY] 034-stack_resize_exploit.dpatch
      Fix exploitable race condition on SMP and HT systems where two
      threads attempt to expand the stack at the same time.  This is
      CAN-2005-0001 (happy new year!) (Andres Salomon).
    - [SECURITY] 035-do_brk_security_fixes-2.dpatch
      Further do_brk fixes; just to be safe, lock everywhere do_brk
      is used (Andres Salomon).
    - Apply patch to fix compat cmsg_len checks (Christoph Hellwig).
    - Backport EFI partition support fixes from 2.6.10.  Patch supplied by Tore
      Anderson <tore@debian.org> (Christoph Hellwig) (Bug #281905).
    - scsi-ioctl.dpatch
      Provide a warning about unknown opcodes (Andres Salomon).

 -- Sven Luther <luther@debian.org>  Sat, 29 Jan 2005 14:04:37 +0100

kernel-patch-powerpc-2.6.8 (2.6.8-9) unstable; urgency=high

  * Built against kernel-source 2.6.8-12 :
    - [powerpc - prep] Fix bad irq assignement for pci devices on motorola
      powerstack boxes. (Closes: #287933) (Sven Luther)
    - add dh_fixperms to the build targets to kernel-patch-debian-2.6.8
      to ensure that the permissions of the files in this package are
      sensible. (See: Bug#288279) (Simon Horman)
    - [SECURITY] Fix vulnerability in the ELF loader code allowing 
      local attacker to execute code as root, CAN-2004-1235. 
      (Maximilian Attems)
    - Added backport of qla1280 driver from 2.6.10. (Norbert Tretkowski)
    - [SECURITY] 028-do_brk_security_fixes.dpatch
      Drop Marcelo's fix for this; use Linus' instead.
      Fix local root vulnerability for various do_brk() calls;
      ensure an exclusive lock on memory while modifying it; CAN-2004-1235
      (Andres Salomon) (Bug: #289155).
    - [SECURITY] 029-random_poolsize_overflow.dpatch
      drivers/char/random allows you to set the poolsize; its sanity checking
      on that input isn's very good.  We fix that here.
      See http://seclists.org/lists/fulldisclosure/2005/Jan/0270.html for
      more details.  This fixes #3 on that list (Andres Salomon).
    - [SECURITY] 030-moxa_user_copy_checking.dpatch
      The moxa driver does some ugly things w/ signed integers.  This fixes
      #4 on Brad Spengler's advisory (Andres Salomon).
    - [SECURITY] 031-sg_scsi_ioctl_int_overflows.dpatch
      SG ioctl stuff doesn't actually check whether the scsi command length
      is positive.  #5 on the above advisory (Andres Salomon).

 -- Sven Luther <luther@debian.org>  Sat,  8 Jan 2005 14:47:16 +0100

kernel-patch-powerpc-2.6.8 (2.6.8-8) unstable; urgency=high

  * Moved remaining powerpc patches (pegasos-via-ide and legacy-serial)
    to the common kernel-source package. (Sven Luther)

  * Rebuilt against kernel-source-2.6.8-11. (Sven Luther)

  * Removed kernel-patch-powerpc package, since all the powerpc patches are
    now part of kernel-source. Next version of kernel-source-2.6.8 should have
    a conflict/replace/provides, but for now please remove it by hand.

 -- Sven Luther <luther@debian.org>  Wed, 29 Dec 2004 11:42:34 +0100

kernel-patch-powerpc-2.6.8 (2.6.8-7) unstable; urgency=high

  * Rebuilt against kernel-source 2.6.8-10.
    - [SECURITY] Fix problems in binfmt_elf and binfmt_aout loaders; see
      http://isec.pl/vulnerabilities/isec-0017-binfmt_elf.txt for more
      details (Andres Salomon).
    - Adding drivers-serial-8250-ioremap-fix.dpatch: a patch from Alex
      Williamson that prevents setserial from crashing the kernel.
      See: http://marc.theaimsgroup.com/?l=linux-kernel&m=109913237604338&w=2
      (Dann Frazier)
    - Split out aic7xxx-update patch into separate changesets, and drop
      the pci-id-table and hostraid changesets; people are still reporting
      problems having the driver detect their controller (Andres Salomon).
    -  VLAN updates (Potential fix for: Bug#280743) (Simon Horman)
    - copy_to_user checking in select.c
      (Potential fix for: Bug#278183) (Simon Horman)
    - Remove bogus DMA blacklist for RICOH CD-R/RW MP7083A (Maximilian Attems)
    - tmpfs inode accounting leak fix (Maximilian Attems)
    - Fix disconnected dentries on NFS exports (Maximilian Attems)
    - [SECURITY] Further smbfs overflow fixes, stolen from -ac tree
      (Andres Salomon).

  * Enabled the USB IrDA FIR Dongle device driver (CONFIG_USB_IRDA), which
    was apparently forgotten in the transition from 2.4.

  * Modified debian/rules to easily create or not the kernel-image packages.
    Drop the kernel-image metapackages since we have kernel-latest already.
    (Sven Luther)



=== debian/control ===
Source: kernel-patch-powerpc-2.6.8
Section: devel
Priority: optional
Build-Depends: debhelper (>=4), bzip2, kernel-package, kernel-tree-2.6.8-13, m4
Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Sven Luther <luther@debian.org>
Standards-Version: 3.6.1

Package: kernel-headers-2.6.8
Architecture: powerpc
Description: header files for the Linux kernel version 2.6.8
 .
 This package provides kernel headers files for 2.6.8.

Package: kernel-build-2.6.8-power3
Architecture: powerpc
Depends: kernel-headers-2.6.8
Description: build infrastructure for kernel version 2.6.8-power3
 .
 Together with kernel-headers-2.6.8, this package provides the
 infrastructure for building additional modules for 2.6.8-power3.

Package: kernel-image-2.6.8-power3
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-power3
 .
 This package contains the Linux kernel for version 2.6.8-power3.
 It is intended to be run on PowerPC machines with a single Power3
 processor.

Package: kernel-build-2.6.8-power3-smp
Architecture: powerpc
Depends: kernel-headers-2.6.8
Description: build infrastructure for kernel version 2.6.8-power3-smp
 .
 Together with kernel-headers-2.6.8, this package provides the
 infrastructure for building additional modules for 2.6.8-power3-smp.

Package: kernel-image-2.6.8-power3-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-power3-smp
 .
 This package contains the Linux kernel for version 2.6.8-power3-smp.
 It is intended to be run on PowerPC machines with two or more
 Power3 processors, like some IBM RS/6000 boxen.

Package: kernel-build-2.6.8-power4
Architecture: powerpc
Depends: kernel-headers-2.6.8
Description: build infrastructure for kernel version 2.6.8-power4
 .
 Together with kernel-headers-2.6.8, this package provides the
 infrastructure for building additional modules for 2.6.8-power4.

Package: kernel-image-2.6.8-power4
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-power4
 .
 This package contains the Linux kernel for version 2.6.8-power4.
 It is intended to be run on PowerPC machines with a single Power4
 processor, the most prominent example being the G5 PowerMac by Apple.

Package: kernel-build-2.6.8-power4-smp
Architecture: powerpc
Depends: kernel-headers-2.6.8
Description: build infrastructure for kernel version 2.6.8-power4-smp
 .
 Together with kernel-headers-2.6.8, this package provides the
 infrastructure for building additional modules for 2.6.8-power4-smp.

Package: kernel-image-2.6.8-power4-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-power4-smp
 .
 This package contains the Linux kernel for version 2.6.8-power4-smp.
 It is intended to be run on PowerPC machines with two or more Power4
 processors.  This setup can be found in Apple's dual G5 PowerMacs, as
 well as in a number of IBM RS/6000 boxen, such as the iSeries and
 pSeries machines.

Package: kernel-build-2.6.8-powerpc
Architecture: powerpc
Depends: kernel-headers-2.6.8
Description: build infrastructure for kernel version 2.6.8-powerpc
 .
 Together with kernel-headers-2.6.8, this package provides the
 infrastructure for building additional modules for 2.6.8-powerpc.

Package: kernel-image-2.6.8-powerpc
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-powerpc
 .
 This package contains the Linux kernel for version 2.6.8-powerpc.
 It is intended to be run on single-processor PowerPC machines,
 including all G3 and G4 models by Apple, as well as older PowerMacs.

Package: kernel-build-2.6.8-powerpc-smp
Architecture: powerpc
Depends: kernel-headers-2.6.8
Description: build infrastructure for kernel version 2.6.8-powerpc-smp
 .
 Together with kernel-headers-2.6.8, this package provides the
 infrastructure for building additional modules for 2.6.8-powerpc-smp.

Package: kernel-image-2.6.8-powerpc-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-powerpc-smp
 .
 This package contains the Linux kernel for version 2.6.8-powerpc-smp.
 It is intended to be run on most dual-processor PowerPC machines,
 most notably the Dual G4 PowerMacs by Apple.

=== debian/rules ===
#!/usr/bin/make -f

# debian/rules for kernel-patch-powerpc

# written by Jens Schmalzing <jensen@debian.org>

# debhelper compatibility version
export DH_COMPAT=4

# Set to Yes if we are going to generate the metapackages.
OFFICIAL_VERSION = No

# This is the kernel-tree version we build against 
ktver = 13

# set the build architecture if necessary
DEB_HOST_ARCH ?= $(shell dpkg --print-architecture)

# the flavours we're building for
flavours := $(shell grep -v ^\# debian/flavours)

# cut the upstream version and the Debian revision from the changelog
kernel	:= $(shell head -1 debian/changelog | sed 's/^.*(\(.*\)-.*).*$$/\1/')
debian	:= $(shell head -1 debian/changelog | sed 's/^.*(.*-\(.*\)).*$$/\1/')
version	:= $(shell head -1 debian/changelog | sed 's/^.*(\(.*\)).*$$/\1/')

#some files in debian/ get version numbers and stuff updated on the fly
M4 = m4 -DM4VERSION="$(version)" -DM4KERNEL="$(kernel)" -DM4FLAVOUR="$(flavour)" -DM4TREE="$(kernel)-$(ktver)"
#M4 = sed -e 's%M4VERSION%$(version)%g' -e 's%M4KERNEL%$(kernel)%g' -e 's%M4FLAVOUR%$(flavour)%g' -e 's%M4TREE%$(kernel)-$(ktver)'
debian/%: debian/%.m4
	$(M4) $< > $@

# installation of files and programs
INSTALL_DATA	= install -m 644 -o root -g root
INSTALL_EXEC	= install -m 755 -o root -g root

# build locations - point TMP to a tmpfs for best performance
TMP ?= $(CURDIR)/tmp
KSOURCE	 = $(TMP)/kernel-source-$(kernel)
KFLAVOUR = $(TMP)/kernel-source-$(kernel)-$(flavour)
KDUMMY   = $(TMP)/kernel-image-$(kernel)-$(flavour)_$(version)_powerpc.deb
KHEADERS = $(TMP)/kernel-headers-$(kernel)_$(version)_powerpc.deb

# install locations
KBUILD    = $(CURDIR)/debian/kernel-build-$(kernel)-$(flavour)
KBUILDDOC = $(KBUILD)/usr/share/doc/kernel-build-$(kernel)-$(flavour)
KSRC      = $(KBUILD)/usr/src/kernel-build-$(kernel)-$(flavour)
KIMAGE    = $(CURDIR)/debian/kernel-image-$(kernel)-$(flavour)
KIMAGEDOC = $(KIMAGE)/usr/share/doc/kernel-image-$(kernel)-$(flavour)
KLIB      = $(KIMAGE)/usr/lib/kernel-image-$(kernel)-$(flavour)

# environment for make-kpkg
export APPEND_TO_VERSION=-$(flavour)
export PARALLEL_BUILD=-j2
export INITRD=Yes
export INITRD_OK=WeKnowWhatWeAreDoing
export KPKG_SUBARCH=pmac

# the configure target is responsible for setting up the build arena,
# i.e. unpacking the Debian kernel source and preparing a separate
# build tree for each flavour.

configure: stamp-configure

# the following is the first of a number of loop implementations using
# recursive make.  This provides much easier access to the loop
# variable than extracting it from the target.  In order to safeguard
# against infinite loops, the recursion level is checked for the
# critical targets.  This particular example calls a common target,
# then runs the loop, and also includes some common commands to
# process after the loop.

stamp-configure: \
stamp-configure-prepare \
$(foreach flavour,$(flavours),stamp-configure-flavour-$(flavour))

	cd $(KSOURCE); APPEND_TO_VERSION='' make-kpkg configure

	touch $@

# unpack the Debian kernel source, add a default .config file and the
# necessary Debian files (changelog, control, copyright, post-install,
# and official)
stamp-configure-prepare:

	test -d $(dir $(KSOURCE)) || mkdir -p $(dir $(KSOURCE))
	tar jxCf $(dir $(KSOURCE)) /usr/src/kernel-source-$(kernel).tar.bz2
	cd $(KSOURCE); /usr/src/kernel-patches/all/$(kernel)/apply/debian $(kernel)-$(ktver)
	#for file in $(shell debian/list patches); do patch -d $(KSOURCE) -p1 < patches/$$file; done

	-$(MAKE) -s -C config default > $(KSOURCE)/.config

	test -d $(KSOURCE)/debian || mkdir $(KSOURCE)/debian
	cd debian; cp -p changelog control copyright post-install $(KSOURCE)/debian
	> $(KSOURCE)/debian/official

	touch $@

ifeq (0,$(MAKELEVEL))

stamp-configure-flavour-%:
	$(MAKE) -f debian/rules stamp-configure-flavour-$* flavour=$*

else
ifeq (1,$(MAKELEVEL))

# create a separate build tree for a given flavour, add the flavour's
# .config and control files
stamp-configure-flavour-$(flavour): \
stamp-configure-prepare

	test -d $(dir $(KFLAVOUR)) || mkdir -p $(dir $(KFLAVOUR))

	cp -al $(KSOURCE) $(KFLAVOUR)

	rm -f $(KFLAVOUR)/.config $(KFLAVOUR)/debian/control
	-$(MAKE) -s -C config $(flavour) > $(KFLAVOUR)/.config
	$(M4) debian/control-dummy.m4 > $(KFLAVOUR)/debian/control

	touch $@

endif
endif

# the build target is responsible for, well, building the kernels and
# modules for each flavour.  To that end, it uses the build target of
# make-kpkg.

ifeq ($(DEB_HOST_ARCH),powerpc)
build: stamp-build
else
build:
endif

stamp-build: \
stamp-configure stamp-build-prepare
	$(MAKE) -f debian/rules $(PARALLEL_BUILD) $(foreach flavour,$(flavours),stamp-build-flavour-$(flavour))
	touch $@

stamp-build-prepare:
	dh_testdir
	touch $@

ifeq (0,$(MAKELEVEL))

stamp-build-flavour-%:
	$(MAKE) -f debian/rules $@

else
ifeq (1,$(MAKELEVEL))

stamp-build-flavour-%:
	$(MAKE) -f debian/rules stamp-build-flavour-$* flavour=$*

else
ifeq (2,$(MAKELEVEL))

# build the pmac kernel and the modules for a given flavour
stamp-build-flavour-$(flavour): \
stamp-configure-flavour-$(flavour) stamp-build-prepare
	cd $(KFLAVOUR); \
	MFLAGS="$(filter-out -j --j%,$(MFLAGS))" \
	MAKEFLAGS="$(filter-out -j --j%,$(MAKEFLAGS))" make-kpkg build
	touch $@

endif
endif
endif

# the install target is responsible for assigning the built kernels
# and modules to the right kernel-image and kernel-modules packages.
# The main work is done through the kernel-image target of make-kpkg.
# The resulting intermediate package is immediately unpacked again and
# its contents re-arranged slightly. The whole process results in one
# kernel-image directory per flavour. Also, the install target puts
# together the build infrastructure for modules.

install: stamp-install

stamp-install: \
stamp-build
	$(MAKE) -f debian/rules $(PARALLEL_BUILD) $(foreach flavour,$(flavours),stamp-install-flavour-$(flavour))
	touch $@

# do the usual checks
stamp-install-prepare:
	dh_testdir
	dh_testroot
	dh_clean

	touch $@

ifeq (0,$(MAKELEVEL))

stamp-install-flavour-%:
	$(MAKE) -f debian/rules $@

else
ifeq (1,$(MAKELEVEL))

stamp-install-flavour-%:
	$(MAKE) -f debian/rules stamp-install-flavour-$* flavour=$*

else
ifeq (2,$(MAKELEVEL))

# create an intermediate kernel-image package from the build tree,
# immediately unpack it into the install directory, and re-arrange a
# few things.  Also, install the build infrastructure for modules from
# the kernel source.

stamp-install-flavour-$(flavour): \
stamp-build-flavour-$(flavour) stamp-install-prepare

# create and unpack the intermediate kernel image package
	cd $(KFLAVOUR); \
	MFLAGS="$(filter-out -j --j%,$(MFLAGS))" \
	MAKEFLAGS="$(filter-out -j --j%,$(MAKEFLAGS))" make-kpkg kernel-image
	dpkg -x $(KDUMMY) $(KIMAGE)

# remove the coff image
	rm -f $(KIMAGE)/boot/vmlinux.coff-$(kernel)-$(flavour)

# copy build infrastructure for kernel modules
	cd $(KFLAVOUR); find scripts -type f ! -name '*.o' | cpio -pd $(KSRC)
	cat debian/build-files | ( cd $(KFLAVOUR); cpio -pd $(KSRC) )

# add some README files and the kernel-source changelog
	$(INSTALL_DATA) debian/README.kernel-image $(KIMAGEDOC)/NEWS.Debian
	$(INSTALL_DATA) /usr/share/doc/kernel-source-$(kernel)/changelog.Debian.gz \
		$(KIMAGEDOC)/changelog-kernel-source.Debian.gz
	echo Built against kernel-tree-$(ktver). > $(KIMAGEDOC)/kernel-tree-version
	mkdir -p $(KBUILDDOC)
	$(INSTALL_DATA) debian/README.kernel-build $(KBUILDDOC)/README.Debian

	touch $@

endif
endif
endif

# the binary target is responsible for creating Debian packages from
# the various package directories created by the install target.
# Also, it creates additional packages such as kernel-headers directly
# from the build directories.

ifeq ($(DEB_HOST_ARCH),powerpc)
binary: \
binary-kernel-headers-$(kernel) \
$(foreach flavour,$(flavours),binary-flavour-$(flavour))
else
binary: binary-arch binary-indep
binary-arch:
binary-indep:
endif

ifeq (0,$(MAKELEVEL))

binary-flavour-%:
	$(MAKE) -f debian/rules binary-flavour-$* flavour=$*

else

## kernel-patch-powerpc-2.6.8 2.6.8-13sarge1

=== debian/changelog ===
kernel-patch-powerpc-2.6.8 (2.6.8-13sarge1) oldstable-security; urgency=high

  * Rebuild against kernel-tree-2.6.8-17sarge1
    * compat_sys_mount-NULL-data_page.dpatch
      [SECURITY] Fix oops in compat_sys_mount triggered by NULL data_page
      See CVE-2006-7203
    * pppoe-socket-release-mem-leak.dpatch
      [SECURITY] fix unpriveleged memory leak when a PPPoE socket is released
      after connect but before PPPIOCGCHAN ioctl is called upon it
      See CVE-2007-2525
    * dn_fib-out-of-bounds.dpatch, ipv4-fib_props-out-of-bounds.dpatch
      [SECURITY] Fix out of bounds condition in dn_fib_props[]
      See CVE-2007-2172
    * aacraid-ioctl-perm-check.dpatch
      [SECURITY] Require admin capabilities to issue ioctls to aacraid devices
      See CVE-2007-4308
    * reset-pdeathsig-on-suid.dpatch
      [SECURITY] Fix potential privilege escalation caused by improper
      clearing of the child process' pdeath signal.
      See CVE-2007-3848
    * bluetooth-l2cap-hci-info-leaks.dpatch
      [SECURITY] Fix information leaks in setsockopt() implementations
      See CVE-2007-1353
    * coredump-only-to-same-uid.dpatch
      [SECURITY] Fix an issue where core dumping over a file that
      already exists retains the ownership of the original file
      See CVE-2007-6206
    * i4l-isdn_ioctl-mem-overrun.dpatch
      [SECURITY] Fix potential isdn ioctl memory overrun
      See CVE-2007-6151
    * cramfs-check-block-length.dpatch
      [SECURITY] Add a sanity check of the block length in cramfs_readpage to
      avoid a potential oops condition
      See CVE-2006-5823
    * ext2-skip-pages-past-num-blocks.dpatch
      [SECURITY] Add some sanity checking for a corrupted i_size in
      ext2_find_entry()
      See CVE-2006-6054
    * minixfs-printk-hang.dpatch
      [SECURITY] Rate-limit printks caused by accessing a corrupted minixfs
      filesystem that would otherwise cause a system to hang (printk storm)
      See CVE-2006-6058
    * isdn-net-overflow.dpatch
      [SECURITY] Fix potential overflows in the ISDN subsystem
      See CVE-2007-6063
    * prevent-stack-growth-into-hugetlb-region.dpatch
      [SECURITY] Prevent OOPS during stack expansion when the VMA crosses
      into address space reserved for hugetlb pages.
      See CVE-2007-3739
    * cifs-honor-umask.dpatch
      [SECURITY] Make CIFS honor a process' umask
      See CVE-2007-3740
    * hugetlb-prio_tree-unit-fix.dpatch
      [SECURITY] Fix misconversion of hugetlb_vmtruncate_list to prio_tree
      which could be used to trigger a BUG_ON() call in exit_mmap.
      See CVE-2007-4133
    * amd64-zero-extend-32bit-ptrace.dpatch
      [SECURITY] Zero extend all registers after ptrace in 32-bit entry path.
      See CVE-2007-4573
    * usb-pwc-disconnect-block.dpatch
      [SECURITY] Fix issue with unplugging webcams that use the pwc driver.
      If userspace still has the device open it can result, the driver would
      wait for the device to close, blocking the USB subsystem.
      See CVE-2007-5093
    * powerpc-chrp-null-deref.dpatch
      [SECURITY][powerpc] Fix NULL pointer dereference if get_property
      fails on the subarchitecture
      See CVE-2007-6694
    * random-bound-check-ordering.dpatch
      [SECURITY] Fix stack-based buffer overflow in the random number
      generator
      See CVE-2007-3105
    * mmap-VM_DONTEXPAND.dpatch
      [SECURITY] Add VM_DONTEXPAND to vm_flags in drivers that register
      a fault handler but do not bounds check the offset argument
      See CVE-2008-0007

 -- dann frazier <dannf@debian.org>  Tue, 19 Feb 2008 20:54:09 -0700

kernel-patch-powerpc-2.6.8 (2.6.8-13) oldstable; urgency=high

  * Rebuild against kernel-tree-2.6.8-17
    [ Simon Horman ]
    * drivers-net-via-rhine-wol-oops.dpatch (removed):
      This patch breaks the via-rhine driver and 2.6.8 and is
      completely bogus for this version of the kernel
      (closes: #311357)

    * drivers-media-vidio-bttv-vc100xp-detect.dpatch
      Allow Leadtek WinFast VC100 XP cards to work.

    * fs-jbd-checkpoint-assertion.dpatch
      Fix possible false assertion failure in log_do_checkpoint(). We might fail
      to detect that we actually made a progress when cleaning up the checkpoint
      lists if we don't retry after writing something to disk.

    * mm-rmap-out-of-bounds-pte.dpatch
      Stop try_to_unmap_cluster() passing out-of-bounds pte to pte_unmap()

    * net-ipv4-netfilter-ip_queue-deadlock.dpatch
      Fix deadlock with ip_queue and tcp local input path.

    * asm-i386-mem-clobber.dpatch:
      Make sure gcc doesn't reorder memory accesses in strncmp and friends on
      i386.

    * drivers-acpi-pci_irq-elcr.dpatch:
      Make sure we call acpi_register_gsi() even for default PCI interrupt
      assignment. That's the part that keeps track of the ELCR register, and we
      want to make sure that the PCI interrupts are properly marked level/low.

    [ dann frazier ]
    * Merge in applicable fixes from 2.6.12.4
       - netfilter-deadlock-ip6_queue.dpatch
       - rocket_c-fix-ldisc-ref-count.dpatch
       - early-vlan-fix.dpatch

    [ Simon Horman ]
    * drivers-sata-promise-sataii_tx2_tx4.dpatch
      Add SATAII TX2 and TX2/TX4 support to sata promise driver
      (Closes: #317286)

    * module-per-cpu-alignment-fix.dpatch
      Module per-cpu alignment cannot always be met
      From 2.6.12.5

    * genelink-usbnet-skb-typo.dpatch
      fix gl_skb/skb type error in genelink driver in usbnet
      Backported From 2.6.12.6

    * drivers-ide-ppp-pmac-build.dpatch
      Make sure BLK_DEV_IDEDMA_PCI is defined for pmac ide driver builds
      (closes: #321442)

    * fs-ext3-nfs-parent-fix.dpatch
      ext3 file systems mounted over nfs may lookup .. in dx directories
      causing an oops.
      (closes: #323557)

    * sparc-request_irq-in-RTC-fix.dpatch
      Use SA_SHIRQ in sparc specific code.
      From 2.6.13.1

    * forcedeth-init-link-settings-in-nv_open.patch


=== debian/control ===
Source: kernel-patch-powerpc-2.6.8
Section: devel
Priority: optional
Build-Depends: debhelper (>=4), bzip2, kernel-package, kernel-tree-2.6.8-17sarge1, m4, module-init-tools
Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Sven Luther <luther@debian.org>
Standards-Version: 3.6.1

Package: kernel-headers-2.6.8-4
Architecture: powerpc
Description: header files for the Linux kernel version 2.6.8-4
 .
 This package provides kernel headers files for 2.6.8-4.

Package: kernel-build-2.6.8-4-power3
Architecture: powerpc
Depends: kernel-headers-2.6.8-4
Description: build infrastructure for kernel version 2.6.8-4-power3
 .
 Together with kernel-headers-2.6.8-4, this package provides the
 infrastructure for building additional modules for 2.6.8-4-power3.

Package: kernel-image-2.6.8-4-power3
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-4-power3
 .
 This package contains the Linux kernel for version 2.6.8-4-power3.
 It is intended to be run on PowerPC machines with a single Power3
 processor.

Package: kernel-build-2.6.8-4-power3-smp
Architecture: powerpc
Depends: kernel-headers-2.6.8-4
Description: build infrastructure for kernel version 2.6.8-4-power3-smp
 .
 Together with kernel-headers-2.6.8-4, this package provides the
 infrastructure for building additional modules for 2.6.8-4-power3-smp.

Package: kernel-image-2.6.8-4-power3-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-4-power3-smp
 .
 This package contains the Linux kernel for version 2.6.8-4-power3-smp.
 It is intended to be run on PowerPC machines with two or more
 Power3 processors, like some IBM RS/6000 boxen.

Package: kernel-build-2.6.8-4-power4
Architecture: powerpc
Depends: kernel-headers-2.6.8-4
Description: build infrastructure for kernel version 2.6.8-4-power4
 .
 Together with kernel-headers-2.6.8-4, this package provides the
 infrastructure for building additional modules for 2.6.8-4-power4.

Package: kernel-image-2.6.8-4-power4
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-4-power4
 .
 This package contains the Linux kernel for version 2.6.8-4-power4.
 It is intended to be run on PowerPC machines with a single Power4
 processor, the most prominent example being the G5 PowerMac by Apple.

Package: kernel-build-2.6.8-4-power4-smp
Architecture: powerpc
Depends: kernel-headers-2.6.8-4
Description: build infrastructure for kernel version 2.6.8-4-power4-smp
 .
 Together with kernel-headers-2.6.8-4, this package provides the
 infrastructure for building additional modules for 2.6.8-4-power4-smp.

Package: kernel-image-2.6.8-4-power4-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-4-power4-smp
 .
 This package contains the Linux kernel for version 2.6.8-4-power4-smp.
 It is intended to be run on PowerPC machines with two or more Power4
 processors.  This setup can be found in Apple's dual G5 PowerMacs, as
 well as in a number of IBM RS/6000 boxen, such as the iSeries and
 pSeries machines.

Package: kernel-build-2.6.8-4-powerpc
Architecture: powerpc
Depends: kernel-headers-2.6.8-4
Description: build infrastructure for kernel version 2.6.8-4-powerpc
 .
 Together with kernel-headers-2.6.8-4, this package provides the
 infrastructure for building additional modules for 2.6.8-4-powerpc.

Package: kernel-image-2.6.8-4-powerpc
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-4-powerpc
 .
 This package contains the Linux kernel for version 2.6.8-4-powerpc.
 It is intended to be run on single-processor PowerPC machines,
 including all G3 and G4 models by Apple, as well as older PowerMacs.

Package: kernel-build-2.6.8-4-powerpc-smp
Architecture: powerpc
Depends: kernel-headers-2.6.8-4
Description: build infrastructure for kernel version 2.6.8-4-powerpc-smp
 .
 Together with kernel-headers-2.6.8-4, this package provides the
 infrastructure for building additional modules for 2.6.8-4-powerpc-smp.

Package: kernel-image-2.6.8-4-powerpc-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.8-4-powerpc-smp
 .
 This package contains the Linux kernel for version 2.6.8-4-powerpc-smp.
 It is intended to be run on most dual-processor PowerPC machines,
 most notably the Dual G4 PowerMacs by Apple.

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 OFFICIAL_VERSION = No
 
 # This is the kernel-tree version we build against 
-ktver = 13
+ktver = 17sarge1
 
 # set the build architecture if necessary
 DEB_HOST_ARCH ?= $(shell dpkg --print-architecture)
@@ -23,9 +23,10 @@
 kernel	:= $(shell head -1 debian/changelog | sed 's/^.*(\(.*\)-.*).*$$/\1/')
 debian	:= $(shell head -1 debian/changelog | sed 's/^.*(.*-\(.*\)).*$$/\1/')
 version	:= $(shell head -1 debian/changelog | sed 's/^.*(\(.*\)).*$$/\1/')
+abiname	:= $(shell cat debian/abiname)
 
 #some files in debian/ get version numbers and stuff updated on the fly
-M4 = m4 -DM4VERSION="$(version)" -DM4KERNEL="$(kernel)" -DM4FLAVOUR="$(flavour)" -DM4TREE="$(kernel)-$(ktver)"
+M4 = m4 -DM4VERSION="$(version)" -DM4KERNEL="$(kernel)" -DM4FLAVOUR="$(flavour)" -DM4TREE="$(kernel)-$(ktver)" -DM4ABINAME="$(abiname)"
 #M4 = sed -e 's%M4VERSION%$(version)%g' -e 's%M4KERNEL%$(kernel)%g' -e 's%M4FLAVOUR%$(flavour)%g' -e 's%M4TREE%$(kernel)-$(ktver)'
 debian/%: debian/%.m4
 	$(M4) $< > $@
@@ -38,19 +39,19 @@
 TMP ?= $(CURDIR)/tmp
 KSOURCE	 = $(TMP)/kernel-source-$(kernel)
 KFLAVOUR = $(TMP)/kernel-source-$(kernel)-$(flavour)
-KDUMMY   = $(TMP)/kernel-image-$(kernel)-$(flavour)_$(version)_powerpc.deb
-KHEADERS = $(TMP)/kernel-headers-$(kernel)_$(version)_powerpc.deb
+KDUMMY   = $(TMP)/kernel-image-$(kernel)-$(abiname)-$(flavour)_$(version)_powerpc.deb
+KHEADERS = $(TMP)/kernel-headers-$(kernel)-$(abiname)_$(version)_powerpc.deb
 
 # install locations
-KBUILD    = $(CURDIR)/debian/kernel-build-$(kernel)-$(flavour)
-KBUILDDOC = $(KBUILD)/usr/share/doc/kernel-build-$(kernel)-$(flavour)
-KSRC      = $(KBUILD)/usr/src/kernel-build-$(kernel)-$(flavour)
-KIMAGE    = $(CURDIR)/debian/kernel-image-$(kernel)-$(flavour)
-KIMAGEDOC = $(KIMAGE)/usr/share/doc/kernel-image-$(kernel)-$(flavour)
-KLIB      = $(KIMAGE)/usr/lib/kernel-image-$(kernel)-$(flavour)
+KBUILD    = $(CURDIR)/debian/kernel-build-$(kernel)-$(abiname)-$(flavour)
+KBUILDDOC = $(KBUILD)/usr/share/doc/kernel-build-$(kernel)-$(abiname)-$(flavour)
+KSRC      = $(KBUILD)/usr/src/kernel-build-$(kernel)-$(abiname)-$(flavour)
+KIMAGE    = $(CURDIR)/debian/kernel-image-$(kernel)-$(abiname)-$(flavour)
+KIMAGEDOC = $(KIMAGE)/usr/share/doc/kernel-image-$(kernel)-$(abiname)-$(flavour)
+KLIB      = $(KIMAGE)/usr/lib/kernel-image-$(kernel)-$(abiname)-$(flavour)
 
 # environment for make-kpkg
-export APPEND_TO_VERSION=-$(flavour)
+export APPEND_TO_VERSION=-$(abiname)-$(flavour)
 export PARALLEL_BUILD=-j2
 export INITRD=Yes
 export INITRD_OK=WeKnowWhatWeAreDoing
@@ -219,7 +220,7 @@
 	dpkg -x $(KDUMMY) $(KIMAGE)
 
 # remove the coff image
-	rm -f $(KIMAGE)/boot/vmlinux.coff-$(kernel)-$(flavour)
+	rm -f $(KIMAGE)/boot/vmlinux.coff-$(kernel)-$(abiname)-$(flavour)
 
 # copy build infrastructure for kernel modules
 	cd $(KFLAVOUR); find scripts -type f ! -name '*.o' | cpio -pd $(KSRC)
@@ -247,16 +248,3 @@
 ifeq ($(DEB_HOST_ARCH),powerpc)
 binary: \
 binary-kernel-headers-$(kernel) \
-$(foreach flavour,$(flavours),binary-flavour-$(flavour))
-else
-binary: binary-arch binary-indep
-binary-arch:
-binary-indep:
-endif
-
-ifeq (0,$(MAKELEVEL))
-
-binary-flavour-%:
-	$(MAKE) -f debian/rules binary-flavour-$* flavour=$*
-
-else
